#!/perl/bin/perl
#
# encode.pl 2009/9/12
# MP4生成スクリプト
#
# segwrapperの場所
use lib 'C:\perlrtmp\lib';
#
###################################
use segwrapper; 
use Win32::Process qw( :DEFAULT STILL_ACTIVE );
use Win32;
use File::Copy;
require 'define.pl';
$btsname = $ARGV[0];
$errname = $ARGV[1];
$stday = $ARGV[2];
$stim = $ARGV[3];
$stim =~ s/:00$/:$oftim/;
$etim = $ARGV[4];
$ch = $ARGV[5];
if($ARGV[6] eq 0){ $RwIPOD = ""; }
$abtfile = $btsname . '.abt';
$packet_size = 4096;

&unlink_f("$abtfile");	#処理中断指示をクリア

open(PK, ">$log_folder\\prelock");
flock(PK, 2);

if(-f "$btsname.np99"){	# すでに他のプロセスが、エンコード宣言してる
	close(PK);
	exit();
}else{
	&create_np("$btsname.np99");	# 順番待ち宣言
	close(PK);
}

open(LK, ">$log_folder\\nowlock");

while(){
	if(flock(LK, 6)){ last; }
	if(-f "$abtfile"){
		&unlink_f("$abtfile");
		close(LK);
		&unlink_f("$btsname.np99");
		exit(0);
	}
	sleep(1);
}

&create_np("$btsname.np");	# 処理開始
&unlink_f("$btsname.np99");

&create_np("$btsname.np98");
&expire_file($mp4_folder, '*', 'NoLock', $ExpireDay * 86400);
&create_np("$btsname.np");
$s_stday = $stday; $s_stday =~ s:/::g;
$s_stim = $stim; $s_stim =~ s/://g;
$e_etim = $etim; $e_etim =~ s/://g;
$file = $s_stday . "-" . $s_stim . "-" . $e_etim . "-" . $ch;
$opt = O_RDONLY | O_BINARY;
eval { $opt |= O_LARGEFILE; };
$Efr = 0;
if(open(OTS, ">$btsname.ts")){
	binmode(OTS);
	segwrapper::segopen($handle, $file, $opt);
	while(segwrapper::segread($handle, my $buf, $packet_size)) {
		print OTS $buf;
		if(-f "$abtfile"){
			&unlink_f("$abtfile");
			$Efr = 1;
			last;
		}
	}
	segwrapper::segclose($handle);
	close(OTS);
}else{
	$Efr = 1;
}

&unlink_f("$btsname.np98");

if($Efr eq 1){
	&unlink_f("$btsname.ts");
}else{
	$fiszts = (-s "$btsname.ts");
	if($fiszts eq 0){
		&unlink_f("$btsname.ts");
		&create_np("$errname");
	}else{
		&create_np("$btsname.np4");
		$retc = &exec_proc("$startCmd$TSConverter $TSCO{$ch} \"$btsname.ts\"", $gtimeout);
		if($retc eq -1){
			&unlink_f("$btsname.np4");
			&unlink_f("$btsname.mp4");
		}elsif(!(-f "$btsname.mp4")){
			&unlink_f("$btsname.np4");
			&create_np("$errname");
		}else{
			&unlink_f("$btsname.np4");
			&pnenc();
			&unlink_f("$btsname.np11");
			if($errf ne 0){
				&create_np("$errname");
			}else{
	 			if(($RwIPOD ne "") && ($iencM{$ch} ne 0)){
					if($iencM{$ch} eq 1){ $errf = &venc(); }
					elsif($iencM{$ch} eq 2){ $errf = &aenc(); }
					elsif($iencM{$ch} eq 3){ $errf = &vaenc(); }
					else{ &nenc(); }
					if(($errf ne 0) && ($retc ne -1)){ &nenc(); }
					&unlink_f("$btsname.np1");
				}
			}
		}
		&unlink_f("$btsname" . "_tmp.mp4");
		&unlink_f("$btsname.txt");
		&unlink_f("$btsname.aac");
		&unlink_f("$btsname.264");
		&unlink_f("$btsname.ts");
	}
}
&unlink_f("$btsname.np");
close(LK);
exit(0);

sub pnenc {
	$errf = 0;
	&create_np("$btsname.np11");
	$retc = &exec_proc("$startCmd$MP4Box -quiet -ipod $btsname.mp4", $gtimeout);
	if($retc ne 0){
		&unlink_f("$btsname.mp4");
		$errf = 5;
	}
}

sub nenc {
	$errf = 0;
	&create_np("$btsname.np1");
	$retc = &exec_proc("$startCmd$MP4Box -quiet -ipod -add $btsname.mp4 -new $btsname$RwIPOD.mp4", $gtimeout);
	if($retc ne 0){
		&unlink_f("$btsname$RwIPOD.mp4");
		$errf = 5;
	}
}

sub venc {
	local($errf);
	$errf  = 0;
	&create_np("$btsname.np3");
	$retc = &exec_proc("$startCmd$FFMpeg -threads 4 -i $btsname.mp4 -vcodec libx264 -s 320x180 -r 14.985015 -b 128000 -acodec copy -f ipod  $btsname$RwIPOD.mp4", $gtimeout);
	&unlink_f("$btsname.np3");
	if((-f "$btsname$RwIPOD.mp4") && ($retc eq 0)){
		&create_np("$btsname.np1");
		$retc = &exec_proc("$startCmd$MP4Box -quiet -ipod $btsname$RwIPOD.mp4", $gtimeout);
		if($retc ne 0){
			&unlink_f("$btsname$RwIPOD.mp4");
			$errf = 5;
		}
	}else{
		&unlink_f("$btsname$RwIPOD.mp4");
		$errf = 1;
	}
	return $errf;
}


sub aenc {
	local($errf);
	$errf  = 0;
	&create_np("$btsname.np2");
	$retc = &exec_proc("$startCmd$AACDec -if $btsname.mp4 -of $btsname.wav", $gtimeout);
	&unlink_f("$btsname.np2");
	if((-f "$btsname.wav") && ($retc eq 0)){
		&create_np("$btsname.np21");
		$retc = &exec_proc("$startCmd$AACEnc -br 64000 -if $btsname.wav -of $btsname.aactmp", $gtimeout);
		&unlink_f("$btsname.np21");
		&unlink_f("$btsname.wav");
		if((-f "$btsname.aactmp") && ($retc eq 0)){
			&create_np("$btsname.np22");
			$retc = &exec_proc("$startCmd$MP4Box -quiet -ipod -fps 14.985015 -add $btsname.264 -new $btsname$RwIPOD.mp4", $gtimeout);
			&unlink_f("$btsname.np22");
			if((-f "$btsname$RwIPOD.mp4") && ($retc eq 0)){
				&create_np("$btsname.np1");
				$retc = &exec_proc("$startCmd$MP4Box -quiet -ipod -add $btsname.aactmp  $btsname$RwIPOD.mp4", $gtimeout);
				if($retc ne 0){
					&unlink_f("$btsname$RwIPOD.mp4");
					$errf = 5;
				}
				&unlink_f("$btsname.aactmp");
			}else{
				&unlink_f("$btsname$RwIPOD.mp4");
				$errf = 4;
			}
		}else{
			&unlink_f("$btsname.aactmp");
			$errf = 3;
		}
	}else{
		&unlink_f("$btsname.wav");
		$errf = 2;
	}
	return $errf;
}

sub vaenc {
	local($Mp4Final) = @_;
	local($errf);
	$errf  = 0;
	&create_np("$btsname.np3");
	$retc = &exec_proc("$startCmd$FFMpeg -threads 4 -i $btsname.mp4 -vcodec libx264 -s 320x180 -r 14.985015 -b 128000 -f ipod $btsname$RwIPOD.mp4", $gtimeout);
	&unlink_f("$btsname.np3");
	if((-f "$btsname$RwIPOD.mp4") && ($retc eq 0)){
		&create_np("$btsname.np2");
		$retc = &exec_proc("$startCmd$AACDec -if $btsname.mp4 -of $btsname.wav", $gtimeout);
		&unlink_f("$btsname.np2");
		if((-f "$btsname.wav") && ($retc eq 0)){
			&create_np("$btsname.np21");
			$retc = &exec_proc("$startCmd$AACEnc -br 64000 -if $btsname.wav -of $btsname.aactmp", $gtimeout);
			&unlink_f("$btsname.np21");
			&unlink_f("$btsname.wav");
			if((-f "$btsname.aactmp") && ($retc eq 0)){
				&create_np("$btsname.np1");
				$retc = &exec_proc("$startCmd$MP4Box -quiet -ipod -add $btsname.aactmp  $btsname$RwIPOD.mp4", $gtimeout);
				if($retc ne 0){
					&unlink_f("$btsname$RwIPOD.mp4");
					$errf = 5;
				}
			}else{
				&unlink_f("$btsname$RwIPOD.mp4");
				$errf = 3;
			}
			&unlink_f("$btsname.aactmp");
		}else{
			&unlink_f("$btsname$RwIPOD.mp4");
			&unlink_f("$btsname.wav");
			$errf = 2;
		}
	}else{
		&unlink_f("$btsname$RwIPOD.mp4");
		$errf = 1;
	}
	return $errf;
}

sub expire_file {
	($objdir, $objext, $lockf, $Expire) = @_;
	$locktrue = 1;
	if($lockf ne 'NoLock'){
		open(LK, ">$log_folder\\$lockf");
		unless(flock(LK, 6)){ $locktrue = 0; }
	}
	if($locktrue eq 1){
		opendir(DIB,"$objdir");
		while($DirObj = readdir(DIB)){
			if(($objext = '*') || ($DirObj =~ /$objext$/)){
					@retval = stat("$objdir\\$DirObj");
					if($retval[9] < (time - $Expire)){
					unlink("$objdir\\$DirObj");
				}
			}
		}
		closedir(DIB);
		if($lockf ne 'NoLock'){	close(LK); }
	}
}

sub exec_proc {
	local($ProgName, $TimeOut) = @_;
	local($pid, $skey, $rec);
	@grec = ();

	$pid = open(IN, "$ProgName |");
	Win32::Process::Open($ProcessObj, $pid, 0);
	$skey = -1;
	for($i=0; $i <= $TimeOut; $i++){
		sleep(1);
		$ProcessObj->GetExitCode($exitcode);
		if($exitcode != STILL_ACTIVE){
			$skey = 0;
			last;
		}
		if(-f "$abtfile"){
			&unlink_f("$abtfile");
			$skey = -2;
			last;
		}
	}

	if($skey ne 0){
#		Win32::Process::KillProcess($pid, 0);
		system("$killCmd $pid");
		close(IN);
		Win32::Sleep(500);
		if($skey eq -1){		# タイムアウト終了
			&create_np("$errname");
		}
		return -1;
	}else{
		while($rec = <IN>){
			push(@grec, $rec);
		}
		close(IN);
		return 0;
	}
}

sub create_np {
	local($lockFname) = @_;
	open(OTK, ">$lockFname"); close(OTK);
}

sub unlink_f {
	local($unlinkFname) = @_;
	local($i, $retv);
	for($i=0; $i <= 40; $i++){
		unlink "$unlinkFname";
		unless(-f "$unlinkFname"){ last; }
		Win32::Sleep(50);
	}
}

